<script lang="ts">
  import grapesjs from "grapesjs";
  import { onMount } from "svelte";
  import { loadBlocks } from "./lib/blocks";
  import { loadComponents } from "./lib/components";
  import { loadPanels } from "./lib/panels";
  import { loadTraits } from "./lib/traits";
  import AlertMessage from "./widgets/AlertMessage";
  import grapeJsTemplateManager from "grapesjs-template-manager";
  import AlertMyTemplate from "./widgets/AlertMyTemplate";
  import exportZipCustom from "./plugin-custom/export-to-zip";
  import { footerListTemplate } from "./template-list";

  const escapeName = (name) =>
    `${name}`.trim().replace(/([^a-z0-9\w-\:\/]+)/gi, "-");

  const editorOptions = {
    clearOnRender: false,
    container: "#gjs",
    height: "100vh",
    showOffsets: true,
    avoidInlineStyle: false,
    storageManager: {
      type: "firestore",
    },
    plugins: [grapeJsTemplateManager, exportZipCustom],
    pluginsOpts: {
      [grapeJsTemplateManager]: {
        apiKey: "AIzaSyAx6MJTMLlC5RAN2wy9Jf9hw9fdBZRuaG0",
        authDomain: "grapesjs-stores.firebaseapp.com",
        projectId: "grapesjs-stores",
      },
    },
    canvas: {
      styles: ["https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css"],
      scripts: [],
    },
    showDevices: false,
    fromElement: true,
  };

  function setCssLoaded(state: boolean) {
    // oncss loaded
    // AlertMessage.alert('<p class="text-bold">ยินดีต้อนรับ</p>');
  }

  // bm.add('link-replace', {
  //       name: 'link-replace',
  //       category: 'Extra',
  //       label: 'Link Replace',
  //       content: {
  //           removable: false,
  //           draggable: false,
  //           droppable: false,
  //           script: "console.log('the element', this)",
  //           components: "<h2>Test Block</h2>",
  //           content: "<h2>Test Block</h2>",
  //           traits: [{
  //               label: 'Link Replace',
  //               name: 'link-eplace',
  //               changeProp: 1,
  //           }],
  //           style: {
  //               width: '100px',
  //               height: '100px'
  //           }
  //       },
  //       attributes: {
  //           title: 'Link Replace',
  //           class: 'fa fa-external-link'
  //       }
  //   });

  onMount(() => {
    const editor = grapesjs.init(editorOptions);
    // คำสั่ง set content plattern ที่ทำไว้เป็นแบบเพื่อนำไปใช้
    // editor.setComponents(JSON.parse(content.components))

    // Add the button Save
    editor.Panels.addButton("options", [
      {
        id: "export-temp",
        className: "fa fa-floppy-o icon-blank",
        command: "export-temp",
        attributes: { title: "Save DB" },
      },
    ]);

    editor.Commands.add("export-temp", {
      run: function (editor, sender) {
        sender && sender.set("active", 0); // turn off the button
        editor.store();
        editor.runCommand("gjs-export-zip-custom");
      },
    });

    loadTraits(editor);
    loadPanels(editor);
    loadComponents(editor);
    loadBlocks(editor);

    customButton(editor);

    // คำสั่ง set style css
    // editor.setStyle(styleCustom)
  });

  function customButton(editor: any) {
    // Add the button Save
    editor.Panels.addButton("options", [
      {
        id: "template-dialog",
        className: "fa fa-list-alt icon-blank",
        command: "template-dialog",
        attributes: { title: "Template Custom" },
      },
    ]);
    // // Add the command
    editor.Commands.add("template-dialog", {
      run: function (editor, sender) {
        AlertMyTemplate.show("เลือกได้เลย");
        const blockManager = editor.BlockManager;
        const newBlocksEl = blockManager.render(footerListTemplate, {
          external: true,
          // ignoreCategories: true,
        });
        document.getElementById("block-alert-list").appendChild(newBlocksEl);
      },
    });
  }
</script>

<div>
  <link
    href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css"
    rel="stylesheet"
  />
  <div id="gjs" style="width: 100%; height: 100%;" />
</div>

<style lang="sass">
  @import "src/scss-style/index.scss"
</style>
